unit ShellTreeTypes;

interface

Uses
  Sysutils, Comctrls, ShlObj, ActiveX;

const
  STD_DIR = 'C:\';

type
  TLastAction = (la_None,la_RootPidl,la_RootDir,la_Dir);

  TPidls = (PIDL_DESKTOP,PIDL_PROGRAMS,PIDL_CONTROLS,PIDL_PRINTERS,PIDL_PERSONAL,
            PIDL_FAVORITES,PIDL_STARTUP,PIDL_RECENT,PIDL_SENDTO,PIDL_BITBUCKET,
            PIDL_STARTMENU,PIDL_DESKTOPDIRECTORY,PIDL_DRIVES,PIDL_NETWORK,PIDL_NETHOOD,
            PIDL_FONTS,PIDL_TEMPLATES);

  TVisOption  = (TF_FOLDERS,TF_NONFOLDERS,TF_HIDDEN);
  TVisOptions = set of TVisOption;

  PNodeInfo = ^TNodeInfo;
  TNodeInfo = record
    RelativeIDL : PItemIdList;
    AbsoluteIDL : PItemIdList;
    ShellFolder : IShellFolder;
    Expanded    : Boolean;
  end;

  TShellNode = class(TTreeNode)
  public
    NodeInfo : TNodeInfo;
    destructor Destroy; override;
  end;

  EShellInitError = class(Exception)
  end;

var
  Allocator: IMalloc;

implementation

destructor TShellNode.Destroy;
begin
  if (Assigned(NodeInfo.RelativeIDL)) then Allocator.Free(NodeInfo.RelativeIDL);
  if (Assigned(NodeInfo.AbsoluteIDL)) then Allocator.Free(NodeInfo.AbsoluteIDL);
  inherited;
end;

end.
